#
#   PROBE - Vector algebra
#

from math import pi, hypot, atan2, sin, cos

deg = 180 / pi

def add(u, v):
	ux, uy = u
	vx, vy = v
	return (ux + vx, uy + vy)

def subtract(u, v):
	ux, uy = u
	vx, vy = v
	return (ux - vx, uy - vy)

def multiply(c, v):
	x, y = v
	return c * x, c * y

def dot(u, v):
	ux, uy = u
	vx, vy = v
	return ux * vx + uy * vy

def distance(p, q):
	return magnitude(subtract(p, q))

def magnitude(v):
	x, y = v
	return hypot(x, y)

def direction(v):
	x, y = v
	a = atan2(y, x)
	if a < 0:
		a += 2 * pi
	return a * deg

def rectangular(mag, dir):
	a = dir / deg
	return (mag * cos(a), mag * sin(a))
